// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DebugCalculation.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------

extern CPen penR, penG, penB, penBLACK, penY, penP, penGRAY,penBRAUN;
extern CPen *oldpen;
extern CBrush brushWHITE, brushYELLOW,brushY;
extern double dScale;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_BUTTON0, OnButton0)
	ON_COMMAND(ID_BUTTON1, OnButton1)
	ON_COMMAND(ID_BUTTON2, OnButton2)
	ON_COMMAND(ID_BUTTON3, OnButton3)
	ON_COMMAND(ID_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	dScale=2;

	for (int n=0; n<CHARTS_NUMBER; n++) pChart[n]=NULL;

	penR.CreatePen(PS_SOLID,1,RGB(200,0,0));
	penG.CreatePen(PS_SOLID,1,RGB(0,200,0));
	penB.CreatePen(PS_SOLID,1,RGB(0,0,200));
	penBLACK.CreatePen(PS_SOLID,1,RGB(0,0,0));
	penY.CreatePen(PS_SOLID,1,RGB(230,230,0));
	penP.CreatePen(PS_SOLID,1,RGB(200,0,200));
	penGRAY.CreatePen(PS_SOLID,1,RGB(128,128,128));
	penBRAUN.CreatePen(PS_SOLID,1,RGB(255,128,0));

	brushWHITE.CreateSolidBrush(RGB(255,255,255));
	brushYELLOW.CreateSolidBrush(RGB(255,255,217));
	brushY.CreateSolidBrush(RGB(200,200,0));
}

CMainFrame::~CMainFrame()
{
	penR.DeleteObject();
	penG.DeleteObject();
	penB.DeleteObject();
	penBLACK.DeleteObject();
	penY.DeleteObject();
	penP.DeleteObject();
	penGRAY.DeleteObject();
	penBRAUN.DeleteObject();
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	go();
//	MDITile(MDITILE_VERTICAL);
	MDICascade();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

//---------------------------------------------------------------------------

void CMainFrame::OnButton0() { PaintWindow(e0); }
void CMainFrame::OnButton1() { PaintWindow(e1); }
void CMainFrame::OnButton2() { PaintWindow(e2); }
void CMainFrame::OnButton3() { PaintWindow(e3); }
void CMainFrame::OnButton4() { PaintWindow(e4); }

//---------------------------------------------------------------------------

void CMainFrame::PaintWindow(enum CHARTS e)
{
// ,      eType
//   -      
//   -   

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	if (!pChart[e]) 
	{
		//          Data
		(Chart*) pChart[e] = new Chart(e,&d);
		
		switch (e)
		{
			case e0:
			{
				s=" y(x).  0";
				pChart[e]->SetProportional(TRUE,TRUE);
				pChart[e]->SetLabels(1.,1.,"x", "y(x)");

	pChart[e]->AddArray(&d.spl.u, &d.spl.s, NULL, RGB(0,0,200), 1,"");
	pChart[e]->AddArray(NULL, &d.spl.y, NULL, RGB(200,0,0), 2,",    ",FALSE,TRUE);
			}	break;
			case e1:
			{
				s="2D .  1";
				pChart[e]->SetProportional(TRUE,FALSE);
				pChart[e]->SetLabels(1.,1.,"X", "Y");

	pChart[e]->AddArray(&d.spl.splRX1, &d.spl.splRY1, NULL, RGB(0,200,0), 1," ",TRUE);
//	pChart[e]->AddArray(&d.spl.splRX1, &d.spl.splRY1, NULL, RGB(0,200,0), 1," ",TRUE,TRUE);
	pChart[e]->AddArray(&d.spl.splRX1_,&d.spl.splRY1_,NULL, RGB(0,0,200), 1," ");
//	pChart[e]->AddArray(&d.spl.splRX1_,&d.spl.splRY1_,NULL, RGB(0,0,200), 1," ",FALSE,TRUE);
	pChart[e]->AddArray(&d.spl.RX1, &d.spl.RY1, NULL, RGB(200,0,0), 2,",    ",FALSE,TRUE);
			}	break;
			case e2:
			{
				s="2D .  2";
				pChart[e]->SetProportional(TRUE,FALSE);
				pChart[e]->SetLabels(1.,1.,"X", "Y");

	pChart[e]->AddArray(&d.spl.splRX2, &d.spl.splRY2, NULL, RGB(0,200,0), 1," ",TRUE);
//	pChart[e]->AddArray(&d.spl.splRX2, &d.spl.splRY2, NULL, RGB(0,200,0), 1," ",TRUE,TRUE);
	pChart[e]->AddArray(&d.spl.splRX2_,&d.spl.splRY2_,NULL, RGB(0,0,200), 1," ");
//	pChart[e]->AddArray(&d.spl.splRX2_,&d.spl.splRY2_,NULL, RGB(0,0,200), 1," ",FALSE,TRUE);
	pChart[e]->AddArray(&d.spl.RX2, &d.spl.RY2, NULL, RGB(200,0,0), 2,",    ",FALSE,TRUE);
			}	break;
			case e3:
			{
				s="2D .  3";
				pChart[e]->SetProportional(TRUE,FALSE);
				pChart[e]->SetLabels(1.,1.,"X", "Y");

	pChart[e]->AddArray(&d.spl.splRX3, &d.spl.splRY3, NULL, RGB(0,200,0), 1," ",TRUE);
	pChart[e]->AddArray(&d.spl.splRX3_,&d.spl.splRY3_,NULL, RGB(0,0,200), 1," ");
	pChart[e]->AddArray(&d.spl.RX3, &d.spl.RY3, NULL, RGB(200,0,0), 2,",    ",FALSE,TRUE);
			}	break;
			case e4:
			{
				s="2D .  4";
				pChart[e]->SetProportional(TRUE,FALSE);
				pChart[e]->SetLabels(1.,1.,"X", "Y");

	pChart[e]->AddArray(&d.spl.splRX4, &d.spl.splRY4, NULL, RGB(0,200,0), 1," ",TRUE);
	pChart[e]->AddArray(&d.spl.splRX4_,&d.spl.splRY4_,NULL, RGB(0,0,200), 1," ");
	pChart[e]->AddArray(&d.spl.RX4, &d.spl.RY4, NULL, RGB(200,0,0), 2,",    ",FALSE,TRUE);
			}	break;
			default:
			{
				s.Format("CMainFrame::PaintWindow()\n  e=%i",e);
				AfxMessageBox(s);
			}
		}
		LONG style=	WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW | WS_MAXIMIZE;

		if (!pChart[e]->Create(_T(s), style, rectDefault, this))
		{
			AfxMessageBox("!pChart[e]->Create()\n   ");
			return;
		}
		pChart[e]->OnButtonZeroPos();
	}
	else pChart[e]->OnButton();

	pChart[e]->BringWindowToTop();

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
}
//---------------------------------------------------------------------------

void CMainFrame::go()
{
	d.go();
	OnButton4();
	OnButton3();
	OnButton2();
	OnButton1();
	OnButton0();
	AfxMessageBox("  -    ,\n -      'Ctrl',\n -     .");
}
//---------------------------------------------------------------------------
